/*
                        Control Tower Arexx Script
                           Written By J.L. White
                         (C)1995 Merlin's Software
*/

signal on error
signal on syntax
Options Results

Main:
call OpenStuff()
call Docs()
call Routine()
call CloseStuff()
exit
return

GetFile:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetFileNameNT Title
return result


GetPath:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetPathNameNT Title
return result

GetText:
	parse Arg Title, Text
	Address FLY_1 SetString Text
	Address FLY_1 GetStringNT Title
return result


OpenStuff:
	address command "run CT:FLY"
	do while (POS('FLY_1',SHOW('Ports')) = 0)
		address command "wait 1"
		end
	TOASTERLIB="ToasterARexx.port"
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
return

CloseStuff:
	Address FLY_1 Quit
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	exit
return

YesOrNo: procedure
	parse Arg Title,Yes,No
	Address FLY_1 OK_TEXT Yes
	Address FLY_1 CANCEL_TEXT No
	Address FLY_1 AskYesNoNT Title
	if result = "OK" then YesNo = 1
	else YesNo = 0
return YesNo

Info: 
	parse Arg Title,Yes
	Address FLY_1 OK_TEXT Yes
	Address FLY_1 FYINT Title
return

FindDrive:
	address command "C:Info >RAM:FLY-List"
	call open TempFile,"RAM:FLY-List",R
	do until eof(TempFile)
		line = readln(TempFile)
		parse var line Drive" "Rest
		if Drive = "FA0:" then 
			Volume = word(Rest,7)":"
	end
	call close TempFile
	address command "Delete >NIL: RAM:FLY-List"
return Volume

GetFileName: procedure  
   ARG CompleteName
   c = lastpos("/",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return substr(CompleteName, c + 1)


GetPathName: procedure  
   ARG CompleteName
   c = lastpos(":",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return left(CompleteName,c)

Docs:
Answer = YesOrNo(" Do You Need Instructions?"," YES "," NO ")
if Answer = 0 then return 
Text = "
This Macro will FrameGrab Incoming Video\
from Input 1-4 & save the image as a Flyer\
Still. It waits until the user clicks the\
Click To FrameGrab Window or presses the\
GPI trigger from Mouse Port 2. When you do,\
it freezes the video and saves the Still."
Answer = YesOrNo(Text," Continue "," Exit ")
if Answer = 0 then call CloseStuff()

return


Routine:
	Address FLY_1 GetCompressionNT
	Compression = result
	Address FLY_1 GetInputNT
	if result = 1 then do
		Input = "M001"
		Click = "575|330"
		end
	if result = 2 then do
		Input = "M002"
		Click = "610|330"
		end
	if result = 3 then do
		Input = "M003"
		Click = "637|330"
		end
	if result = 4 then do
		Input = "M004"
		Click = "670|330"
		end
	Type = YesOrNo(" Use Mouse Or GPI Trigger?"," MOUSE "," GPI ")
	call Switcher(SGPI,POS)
	Motion = YesOrNo(" Use Motion Removal?"," YES "," NO ")
	DriveName = FindDrive()
	Name = GetFile("Select Path & BaseName For Flyer Stills!   ",DriveName)
	Base = GetFileName(Name)
	if Base = "" then do
		Address FLY_1 OK_TEXT " OK "
		Title = "You Must Enter A Valid Path & Name For Stills!"
		Address FLY_1 FYINT Title
		Address FLY_1 Quit
		exit
		end
	Num = GetText("Enter Number Of\Frames To Grab!","")
	if Num = "" then do
		Address FLY_1 Quit
		exit
		end
	call Set_View(2)
	do i = 1 to Num
		call Switcher(Input)
		if Type = 1 then do
			Address FLY_1 WaitSW "Click Here To FrameGrab Video!"
			end
		else do
			call Switcher(WAIT,GPI)
			end
		Address FLY_1 ClickMouse Click
		call Switcher(MDV1)
		if Motion = 1 then call Switcher(NOMO)
		FileName = Name""right(i,3,'0')
	        call RecordAdd(FileName,4,6,Compression)
		call MakeIcon(FileName,0,'STILL')
		end
	call Set_View(0)
	Address FLY_1 FYINT "Frame Grabbing Is Complete!"
return


syntax:
error:
	Address FLY_1 OK_TEXT " OK "
	Title = "An Error Was Found With This Macro On Line #"SIGL"!"
	Address FLY_1 FYINT Title
	Address FLY_1 Quit
exit
