/*
                        Control Tower Arexx Script
                           Written By J.L. White
                         (C)1995 Merlin's Software
*/

signal on error
signal on syntax
Options Results
CR = '0A'x

Main:
call OpenStuff()
call Docs()
call Routine()
call CloseStuff()
exit
return

GetFile:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetFileNameNT Title
return result


GetPath:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetPathNameNT Title
return result

GetText:
	parse Arg Title, Text
	Address FLY_1 SetString Text
	Address FLY_1 GetStringNT Title
return result


OpenStuff:
	address command "run CT:FLY"
	do while (POS('FLY_1',SHOW('Ports')) = 0)
		address command "wait 1"
		end
	TOASTERLIB="ToasterARexx.port"
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
return

CloseStuff:
	Address FLY_1 Quit
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	exit
return

YesOrNo: procedure
	parse Arg Title,Yes,No
	Address FLY_1 OK_TEXT Yes
	Address FLY_1 CANCEL_TEXT No
	Address FLY_1 AskYesNoNT Title
	if result = "OK" then YesNo = 1
	else YesNo = 0
return YesNo

Info: 
	parse Arg Title,Yes
	Address FLY_1 OK_TEXT Yes
	Address FLY_1 FYINT Title
return

FindDrive:
	address command "C:Info >RAM:FLY-List"
	call open TempFile,"RAM:FLY-List",R
	do until eof(TempFile)
		line = readln(TempFile)
		parse var line Drive" "Rest
		if Drive = "FA0:" then 
			Volume = word(Rest,7)":"
	end
	call close TempFile
	address command "Delete >NIL: RAM:FLY-List"
return Volume

GetFileName: procedure  
   ARG CompleteName
   c = lastpos("/",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return substr(CompleteName, c + 1)


GetPathName: procedure  
   ARG CompleteName
   c = lastpos(":",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return left(CompleteName,c)

Docs:
Answer = YesOrNo(" Do You Need Instructions?"," YES "," NO ")
if Answer = 0 then return 
Text = "This Macro will wait for a GPI pulse out of\
the Second Mouse Port then play a crouton in\
the current project. It then waits until the\
trigger is hit again and plays the next. It\
continues until all the croutons have been\
played. This can be handy for playing foley\
type sound effects in real time.\
 \
To Abort Hit Control C then the GPI button!"
Answer = YesOrNo(Text," Continue "," Exit ")
if Answer = 0 then call CloseStuff()

return


Routine:
	start_loc=croutonspot()
	call croutonpick(LAST)
	project_end=croutonspot()
	call croutonpick(FIRST)
	current_spot=0
	call Switcher(SGPI,POS)
	if ~open('Window','RAW:'0'/'0'/'640'/'150'/Control Tower - Hit Control-C to Abort/NOSIZE/SCREEN','W') then do
		address FYI_1 Quit
    		exit
		end
	do while (current_spot<project_end+1)
   		call croutonpick(current_spot)
   		current_spot=current_spot+1
		Name = croutongettag(OriginalLocation)
  		call writech('Window',"Playing "Name""CR)
		call Switcher(WAIT,GPI)
		call CroutonStop()
		call CroutonRun(Name)
   		end
	call croutonpick(start_loc)
	Address FLY_1 OK_TEXT " OK "
	Address FLY_1 FYINT "All Croutons Have Been Played!"
return


syntax:
error:
	Address FLY_1 OK_TEXT " OK "
	Title = "An Error Was Found With This Macro On Line #"SIGL"!"
	if SIGL ~= 133 & SIGL ~= 15 then
		Address FLY_1 FYINT Title
	else
		Address FLY_1 FYINT "Macro Has Been Aborted!"
	Address FLY_1 Quit
exit
