/*
                        Control Tower Arexx Script
                           Written By J.L. White
                         (C)1995 Merlin's Software
*/

signal on error
signal on syntax
Options Results

Main:
call OpenStuff()
call Docs()
call Routine()
call CloseStuff()
exit
return

GetFile:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetFileNameNT Title
return result


GetPath:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetPathNameNT Title
return result

GetText:
	parse Arg Title, Text
	Address FLY_1 SetString Text
	Address FLY_1 GetStringNT Title
return result


OpenStuff:
	address command "run CT:FLY"
	do while (POS('FLY_1',SHOW('Ports')) = 0)
		address command "wait 1"
		end
	TOASTERLIB="ToasterARexx.port"
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
return

CloseStuff:
	Address FLY_1 Quit
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	exit
return

YesOrNo: procedure
	parse Arg Title,Yes,No
	Address FLY_1 OK_TEXT Yes
	Address FLY_1 CANCEL_TEXT No
	Address FLY_1 AskYesNoNT Title
	if result = "OK" then YesNo = 1
	else YesNo = 0
return YesNo

Info: 
	parse Arg Title,Yes
	Address FLY_1 OK_TEXT Yes
	Address FLY_1 FYINT Title
return

FindDrive:
	address command "C:Info >RAM:FLY-List"
	call open TempFile,"RAM:FLY-List",R
	do until eof(TempFile)
		line = readln(TempFile)
		parse var line Drive" "Rest
		if Drive = "FA0:" then 
			Volume = word(Rest,7)":"
	end
	call close TempFile
	address command "Delete >NIL: RAM:FLY-List"
return Volume

GetFileName: procedure  
   ARG CompleteName
   c = lastpos("/",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return substr(CompleteName, c + 1)


GetPathName: procedure  
   ARG CompleteName
   c = lastpos(":",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return left(CompleteName,c)

Docs:
Answer = YesOrNo(" Do You Need Instructions?"," YES "," NO ")
if Answer = 0 then return 
Text = "This Macro uses your current project croutons\
to record CG pages, framstores, etc. over the\
top of live video as a clip. Simply add what\
croutons you wish to use and tell it to start\
recording. You can pull down the TBAR, click\
on CG croutons, etc. and all this then gets\
recorded as a clip."
Address FLY_1 OK_TEXT " Continue! "
Address FLY_1 FYINT Text

return


Routine:
	Answer = YesOrNo("Are You Sure You Want To Do This?"," YES "," NO ")
	if Answer = 0 then return 
	Address FLY_1 GetCompressionNT
	Compression = result
	DriveName = FindDrive()
	FileName = GetFile("Select Path & Name For Flyer Clip!   ",DriveName)
        call Switcher( DIIM )
	call Set_View(2)
        call Switcher( ENIM )
        call Switcher( M001 )

	Address FLY_1 WaitSW "Click Here To Start Recording Clip"
	call RECORDCLIP(FileName,0,6,Compression)
	Pause = 1
	do while Pause > 0
		call RecordPause(0)
		Address FLY_1 WaitSW "Click Here To Stop Recording Clip"
		call RecordPause(1)
		Pause = YesOrNo("Click OK To Continue Recording\  Or DONE To Stop Recording?"," OK "," DONE ")
		end
/*
	call RecordPause(0)

	Address FLY_1 WaitSW "Click Here To Stop Recording Clip"
	call RecordPause(1)
*/
	call RecordStop()
	call MakeIcon(FileName)
        call Switcher( DIIM )
	call Set_View(0)
        call Switcher( ENIM )

return


syntax:
error:
	Address FLY_1 OK_TEXT " OK "
	Title = "An Error Was Found With This Macro On Line #"SIGL"!"
	Address FLY_1 FYINT Title
	Address FLY_1 Quit
exit
