/*
                        Control Tower Arexx Script
                           Written By J.L. White
                         (C)1995 Merlin's Software
*/

signal on error
signal on syntax
Options Results

Main:
call OpenStuff()
call Docs()
call Routine()
call CloseStuff()
exit
return

GetFile:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetFileNameNT Title
return result


GetPath:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetPathNameNT Title
return result

GetText:
	parse Arg Title, Text
	Address FLY_1 SetString Text
	Address FLY_1 GetStringNT Title
return result


OpenStuff:
	address command "run CT:FLY"
	do while (POS('FLY_1',SHOW('Ports')) = 0)
		address command "wait 1"
		end
	TOASTERLIB="ToasterARexx.port"
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
return

CloseStuff:
	Address FLY_1 Quit
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	exit
return

YesOrNo: procedure
	parse Arg Title,Yes,No
	Address FLY_1 OK_TEXT Yes
	Address FLY_1 CANCEL_TEXT No
	Address FLY_1 AskYesNoNT Title
	if result = "OK" then YesNo = 1
	else YesNo = 0
return YesNo

Info: 
	parse Arg Title,Yes
	Address FLY_1 OK_TEXT Yes
	Address FLY_1 FYINT Title
return

FindDrive:
	address command "C:Info >RAM:FLY-List"
	call open TempFile,"RAM:FLY-List",R
	do until eof(TempFile)
		line = readln(TempFile)
		parse var line Drive" "Rest
		if Drive = "FA0:" then 
			Volume = word(Rest,7)":"
	end
	call close TempFile
	address command "Delete >NIL: RAM:FLY-List"
return Volume

GetFileName: procedure  
   ARG CompleteName
   c = lastpos("/",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return substr(CompleteName, c + 1)


GetPathName: procedure  
   ARG CompleteName
   c = lastpos(":",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return left(CompleteName,c)

Docs:
Answer = YesOrNo(" Do You Need Instructions?"," YES "," NO ")
if Answer = 0 then return 
Text = "This Macro will save the current image in DV1\
as a Flyer Still. It will prompt you for both\
the Still name and Record mode.\
 \
This can be very handy if you have just frame\
grabbed an image or created a CG Page and sent\
it to the buffer."
Address FLY_1 OK_TEXT " Continue! "
Address FLY_1 FYINT Text

return


Routine:
	Address FLY_1 GetCompressionNT
	Compression = result
	DriveName = FindDrive()
	call Switcher(MDV1)
	FileName = GetFile("Select Path & Name For Flyer Still!   ",DriveName)
        call RecordAdd(FileName,4,6,Compression)
	call MakeIcon(FileName,,'STILL')
return


syntax:
error:
	Address FLY_1 OK_TEXT " OK "
	Title = "An Error Was Found With This Macro On Line #"SIGL"!"
	Address FLY_1 FYINT Title
	Address FLY_1 Quit
exit
