/*
                        Control Tower Arexx Script
                           Written By J.L. White
                         (C)1995 Merlin's Software
*/

signal on error
signal on syntax
Options Results

Main:
call OpenStuff()
call Docs()
call Routine()
call CloseStuff()
exit
return

GetFile:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetFileNameNT Title
return result


GetPath:
	parse Arg Title, Path
	Address FLY_1 SetString Path
	Address FLY_1 GetPathNameNT Title
return result

GetTextTC:
	parse Arg Title, Text
	Address FLY_1 SetString Text
	Address FLY_1 GetStringNTTC Title
return result


OpenStuff:
	address command "run CT:FLY"
	do while (POS('FLY_1',SHOW('Ports')) = 0)
		address command "wait 1"
		end
	TOASTERLIB="ToasterARexx.port"
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	call addlib('PROJECT_REXX_PORT' , 0)
	call addlib(TOASTERLIB,0)
return

CloseStuff:
	Address FLY_1 Quit
	call remlib('ToasterARexx.port')
	call remlib('PROJECT_REXX_PORT')
	exit
return

YesOrNo: procedure
	parse Arg Title,Yes,No
	Address FLY_1 OK_TEXT Yes
	Address FLY_1 CANCEL_TEXT No
	Address FLY_1 AskYesNoNT Title
	if result = "OK" then YesNo = 1
	else YesNo = 0
return YesNo

Info: 
	parse Arg Title,Yes
	Address FLY_1 OK_TEXT Yes
	Address FLY_1 FYINT Title
return

FindDrive:
	address command "C:Info >RAM:FLY-List"
	call open TempFile,"RAM:FLY-List",R
	do until eof(TempFile)
		line = readln(TempFile)
		parse var line Drive" "Rest
		if Drive = "FA0:" then 
			Volume = word(Rest,7)":"
	end
	call close TempFile
	address command "Delete >NIL: RAM:FLY-List"
return Volume

GetFileName: procedure  
   ARG CompleteName
   c = lastpos("/",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return substr(CompleteName, c + 1)


GetPathName: procedure  
   ARG CompleteName
   c = lastpos(":",CompleteName)
   if c = 0 then c = lastpos(":",CompleteName)
   return left(CompleteName,c)

Docs:
Answer = YesOrNo(" Do You Need Instructions?"," YES "," NO ")
if Answer = 0 then return 
Text = "
This Macro will adjust the speed of ALL Transitions\
in the current Project to a new user selected Speed!"
Answer = YesOrNo(Text," Continue "," Exit ")
if Answer = 0 then call CloseStuff()

return


Routine:
	Address FLY_1 OK_TEXT " OK "
	Address FLY_1 GetSpeedNT
	Mode = result
	if Mode = 1 then Type = 3
	if Mode = 2 then Type = 0
	if Mode = 3 then Type = 1
	if Mode = 4 then do
		Type = 2
		TimeCode = GetTextTC("Enter New Speed","00:00:00:00")
		Address FLY_1 ConvertTC TimeCode
		Num = result
		end
	start_loc=croutonspot()
	call croutonpick(LAST)
	project_end=croutonspot()
	call croutonpick(FIRST)
	current_spot=0
	do while (current_spot<project_end+1)
   		call croutonpick(current_spot)
   		current_spot=current_spot+1
   		if croutontype()="ALGO" | croutontype()="ANIM" | croutontype()="ILBM" then do
			if Type = 2 then do
				if croutongettag(VariableFcount) > 0 then do
	      				call croutonsettag(FCountMode,Type)
	      				call croutonsettag(NumFramesVariable,Num)
					end
				end
			else
      				call croutonsettag(FCountMode,Type)
      			end
   		end
	call croutonpick(start_loc)

	Address FLY_1 FYINT "Transition Speeds Have ALL Been Changed!"
return


syntax:
error:
	Address FLY_1 OK_TEXT " OK "
	Title = "An Error Was Found With This Macro On Line #"SIGL"!"
	Address FLY_1 FYINT Title
	Address FLY_1 Quit
exit
